#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		sname	mysql
%define		dname	%{sname}d
#-----------------------------------------------------------------------------
Name		:	mariadb
Version		:	10.11.6
Release		:	14.8.0.0%{?dist}
Summary		:	MariaDB is designed as a drop-in replacement of MySQL(R)
Group		:	Applications/Database

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	PostgreSQL
URL		:	https://downloads.mariadb.org
			#https://archive.mariadb.org/mariadb-10.7.3/source/

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	cmake
BuildRequires	:	perl-DBI
BuildRequires	:	unixODBC
BuildRequires	:	pam-devel

Requires	:	/usr/sbin/useradd, /usr/sbin/userdel
Requires	:	/usr/sbin/groupadd, /usr/sbin/groupdel
Requires	:	lfs-bootscripts
Requires	:	chkconfig
Requires	:	sudo,util-linux

Provides	:	mysql
#-----------------------------------------------------------------------------
%description
MariaDB is a community developed branch of MySQL.
MariaDB is a multi-user, multi-threaded SQL database server.
It is a client/server implementation consisting of a server daemon (mysqld)
and many different client programs and libraries. The base package
contains the standard MariaDB/MySQL client programs and generic MySQL files.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%attr(0700,mysql,mysql) %dir %{_var}/lib/%{sname}
%attr(0740,root,root) %{_sysconfdir}/rc.d/init.d/%{sname}d
%config(noreplace) %{_sysconfdir}/security/user_map.conf
%{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/%{sname}/my.cnf
%{_sysconfdir}/%{sname}/my.cnf.d/*
%{_includedir}/%{sname}/server/%{sname}/*
%{_includedir}/%{sname}/server/private/*
%{_includedir}/%{sname}/server/*.h
%{_includedir}/%{sname}/*.h
%{_includedir}/%{sname}/%{sname}/*.h
%{_includedir}/%{sname}/%{name}/*.h
%{_sbindir}/%{sname}d
%{_sbindir}/%{name}d
%{_bindir}/%{sname}*
%{_bindir}/aria*
%{_bindir}/maria*
%{_bindir}/mbstream
%{_bindir}/myisam*
%{_bindir}/my_print_defaults
%{_bindir}/mytop
%{_bindir}/myrocks_hotbackup
%{_bindir}/innochecksum
%{_bindir}/msql2mysql
%{_bindir}/perror
%{_bindir}/replace
%{_bindir}/resolve_stack_dump
%{_bindir}/resolveip
%{_bindir}/sst_dump
%{_bindir}/test-connect-t
%{_bindir}/wsrep_*
%{_prefix}/lib/%{sname}/*
%{_libdir}/lib*.{so*,a}
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/lib%{name}.pc
%{_libdir}/security/pam_user_map.so
%{_datadir}/groonga*
%{_datadir}/%{sname}/*
%{_datadir}/aclocal/%{sname}.m4
%{_defaultdocdir}/%{name}-%{version}/*
%{_mandir}/man1/*.1.gz
%{_mandir}/man8/*.8.gz

#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{sname}d stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{sname}d
  /usr/sbin/userdel %{sname}
  (
  /bin/echo -n "%{name}-%{version}-%{release} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%pre
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{sname}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	%{sname}

    /usr/sbin/useradd 				\
	-r					\
	-c "MySQL/%{name} Server"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{sname}				\
	-s /bin/bash				\
	-d %{_var}/lib/mysql			\
	%{sname}
    fi
  fi

%post
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add %{sname}d
  fi
%{_sysconfdir}/rc.d/init.d/%{sname}d condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		doc
Summary		:       Manual pages documenting API of the mariadb library

#-----------------------------------------------------------------------------
Requires	:	%{name} = %{version}-%{release}

Buildarch	:	noarch

#-----------------------------------------------------------------------------
%description		doc
Summary		:       Manual pages documenting API of the mariadb library

#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root, -)
#Library manual pages
%{_mandir}/man3/{mariadb,mysql}_*.3.gz

#=============================================================================
%prep
%setup -q
#preparing addon directory
tar xf %{SOURCE1}

#adjusting RPM layout
sed -i							\
  -e "s:lib64/:lib/:"					\
  libmariadb/cmake/install.cmake

#-----------------------------------------------------------------------------
#building application
%build

mkdir build
pushd build

cmake								\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}			\
	-D CMAKE_BUILD_TYPE=Release				\
	-D INSTALL_LAYOUT=RPM 					\
	-D INSTALL_SYSCONFDIR=%{_sysconfdir}/mysql		\
	-D INSTALL_SYSCONF2DIR=%{_sysconfdir}/mysql/my.cnf.d	\
	-D INSTALL_LIBDIR=%{_libdir}				\
	-D INSTALL_DOCDIR=share/doc/%{name}-%{version}		\
	-D INSTALL_DOCREADMEDIR=share/doc/%{name}-%{version}	\
	-D INSTALL_MANDIR=share/man				\
	-D INSTALL_MYSQLSHAREDIR=share/%{sname}			\
	-D INSTALL_MYSQLTESTDIR=share/%{sname}/test		\
	-D INSTALL_PLUGINDIR=lib/%{sname}/plugin		\
	-D INSTALL_SBINDIR=sbin                          	\
	-D INSTALL_SCRIPTDIR=bin                         	\
	-D INSTALL_SQLBENCHDIR=share/%{sname}/bench		\
	-D INSTALL_SUPPORTFILESDIR=share/%{sname}		\
	-D PLUGIN_AUTH_PAM=YES					\
	-D MYSQL_DATADIR=%{_var}/lib/%{sname}			\
	-D MYSQL_UNIX_ADDR=/run/%{dname}/%{dname}.sock		\
	-D WITH_EXTRA_CHARSETS=complex				\
	-D WITH_EMBEDDED_SERVER=ON				\
	-D WITH_READLINE=ON 					\
	-D WITH_ZLIB=system					\
	-D WITH_SSL=system					\
	-D SKIP_TESTS=ON					\
	-D TOKUDB_OK=0						\
	-D FETCHCONTENT_UPDATES_DISCONNECTED=ON			\
	..

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}							\
	%{_smp_mflags}						\

popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
pushd build
%{__make}							\
	DESTDIR=%{buildroot}					\
	install

popd

#creating a false pam plugin setup
%{__mkdir_p} %{buildroot}%{_libdir}/%{sname}/plugin/auth_pam_tool_dir
touch    %{buildroot}%{_libdir}/%{sname}/plugin/auth_pam.so
chmod +x %{buildroot}%{_libdir}/%{sname}/plugin/auth_pam.so

%{__mv}								\
	%{buildroot}/%{_lib}/security				\
	%{buildroot}%{_libdir}

#creating data-base directory
%{__mkdir_p} %{buildroot}%{_var}/lib/%{sname}

#installing mysql starting/stopping script
%{__rm} -fr %{buildroot}%{_sysconfdir}/%{sname}/init.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 							\
	%{name}-ok_addon/%{sname}d				\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#removing unneeded script
%{__rm}								\
	%{buildroot}%{_sbindir}/rcmysql

#moving logrotate.d directiv
%{__mv}								\
	%{buildroot}%{_sysconfdir}/%{sname}/logrotate.d		\
	%{buildroot}%{_sysconfdir}

#Adjusting the configuration file
sed -i								\
	-e "s:/etc/:/etc/%{sname}/:"				\
	%{buildroot}%{_sysconfdir}/%{sname}/my.cnf

#removing test directory
%{__rm} -fr							\
	%{buildroot}%{_datadir}/%{sname}/test
	
#To remove static library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.a					\
	-delete

#-----------------------------------------------------------------------------
%changelog

